<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Calculator for magnetostatic energy and demagnetizing factor</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="demagcalc">Calculator for magnetostatic energy and demagnetizing factor </a></h1><p>DISCLAIMER/GPL TERMS AND CONDITIONS: see <a class="el" href="gpl.html">GNU General Public License</a></p>
<h2><a class="anchor" id="s_demagcalc">
Calculator for the magnetostatic energy and demagnetizing factor of a uniformly magnetized ferromagnetic prism</a></h2>
<p>This tool (Javascript program) calculates the magnetostatic self energy and demagnetizing factor of a uniformly magnetized ferromagnetic rectangular prism analytically [1].</p>
<div align="center">
<img src="200_prism.png" alt="200_prism.png"/>
<p><strong>Geometry of a regular prism with edge lengths 2a,2b,2c</strong></p></div>
<p> This provides a quick and simple test if a micromagnetic code calculates the magnetostatic energy correctly. As input the 3 edge lengths of the prism and the magnetization saturation are required.</p>
<p>D<sub>z</sub> is the demagnetizing factor when the body is magnetized uniformly along the z-axis.</p>
 

<script type="text/javascript">
<!--

   function Energy() {
      var a, b, c, Js;
      var pidz, dz;
      var a2, b2, c2, r, abc, ab, bc, ac, rab, rbc, rac;

      a = 1*document.Formular.a.value;
      b = 1*document.Formular.b.value;
      c = 1*document.Formular.c.value;
      Js = 1*document.Formular.Js.value;

      a2 = a*a;
      b2 = b*b;
      c2 = c*c;
      abc = a*b*c;
      bc=b*c;
      ac=a*c;
      ab=a*b;
      r=Math.sqrt(a2+b2+c2);
      rab=Math.sqrt(a2+b2);
      rbc=Math.sqrt(b2+c2);
      rac=Math.sqrt(a2+c2);
      pidz = ((b2-c2)/(2*bc))*Math.log((r-a)/(r+a))
      	+((a2-c2)/(2*ac))*Math.log((r-b)/(r+b))
		+(b/(2*c))*Math.log((rab+a)/(rab-a))
		+(a/(2*c))*Math.log((rab+b)/(rab-b))
      	+(c/(2*a))*Math.log((rbc-b)/(rbc+b))
		+(c/(2*b))*Math.log((rac-a)/(rac+a))
		+2*Math.atan2(ab,c*r)
		+(a2*a+b2*b-2*c2*c)/(3*abc)
		+((a2+b2-2*c2)/(3*abc))*r
		+(c/ab)*(rac+rbc)
		-(rab*rab*rab+rbc*rbc*rbc+rac*rac*rac)/(3*abc);

      dz=pidz/3.1415927;

      var energydensity,energy2;
      var Ms=Js/(4*3.1415927*1e-4);
      energydensity = 2*3.1415927*Ms*Ms*dz/10;
      energy2 = 2*a*2*b*2*c*energydensity*1e-6/(1.38*3);

      document.Formular.energy.value=energydensity/1000;
      document.Formular.dz.value=dz;
      document.Formular.energy2.value=energy2;

   }

   //-->
   </script>
<form name="Formular" action="">
  <table border="0" bgcolor="#33ccff" nosave="" adsfasf="">
     <tbody>
       <tr nosave="">
         <td nosave="">a [nm]</td>
         <td><input type="text" name="a" size="8"></td>
       </tr>
       <tr>
         <td>b [nm]</td>
         <td><input type="text" name="b" size="8"></td>
       </tr>
       <tr>
         <td>c [nm]</td>
         <td><input type="text" name="c" size="8"></td>
       </tr>
       <tr>
         <td>J<sub>s</sub> [Tesla]</td>
         <td><input type="text" name="Js" size="8"></td>
       </tr>
       <tr>
         <td><input type="button" value=" calculate " onclick="Energy()"></td>
       </tr>
       <tr nosave="">
         <td nosave="">demagnetizing factor D<sub>z</sub></td>
         <td><input name="dz" type="text" size="8"></td>
       </tr>
       <tr>
         <td>Energy density [kJ/m<sup>3</sup>]&nbsp;</td>
         <td><input name="energy" type="text" size="8"></td>
       </tr>
	 <tr>
         <td>Energy [k<sub>B</sub>&nbsp;300&nbsp;K]&nbsp;</td>
         <td><input name="energy2" type="text" size="8"></td>
       </tr>
    </tbody>
  </table>
 </form>


<h3><a class="anchor" id="s_demagcalc_explanation">
Explanation</a></h3>
<p>This calculator evaluates the following formula:</p>
<p><img class="formulaInl" alt="$ \begin{array}{l} \pi D_z = \\ \frac{b^2-c^2}{2bc} \ln\left(\frac{\sqrt{a^2+b^2+c^2}-a}{\sqrt{a^2+b^2+c^2}+a}\right)+ \frac{a^2-c^2}{2ac} \ln\left(\frac{\sqrt{a^2+b^2+c^2}-b}{\sqrt{a^2+b^2+c^2}+b}\right)+ \\ \frac{b}{2c} \ln\left(\frac{\sqrt{a^2+b^2}+a}{\sqrt{a^2+b^2}-a}\right)+ \frac{a}{2c} \ln\left(\frac{\sqrt{a^2+b^2}+b}{\sqrt{a^2+b^2}-b}\right)+ \\ \frac{c}{2a} \ln\left(\frac{\sqrt{b^2+c^2}-b}{\sqrt{b^2+c^2}+b}\right)+ \frac{c}{2b} \ln\left(\frac{\sqrt{a^2+c^2}-a}{\sqrt{a^2+c^2}+a}\right)+ \\ 2 \arctan\left(\frac{ab}{c\sqrt{a^2+b^2+c^2}}\right)+ \\ \frac{a^3+b^3-2c^3}{3abc}+ \frac{a^2+b^2-2c^2}{3abc} \sqrt{a^2+b^2+c^2}+ \\ \frac{c}{ab}\left(\sqrt{a^2+c^2}+\sqrt{b^2+c^2}\right)- \\ \frac{(a^2+b^2)^{3/2}+(b^2+c^2)^{3/2}+(c^2+a^2)^{3/2}}{3abc} \end{array} $" src="form_53.png"/></p>
<p>The self energy per volume unit then becomes: <img class="formulaInl" alt="$ 2 \pi D_z M_s^2 $" src="form_54.png"/></p>
<p>Note that: <img class="formulaInl" alt="$ D_x + D_y + D_z = 1 $" src="form_55.png"/></p>
<p>JavaScript code developed, published under GPL, and contributed by Rok Dittrich.</p>
<p>[1] Amikam Aharoni, "Demagnetizing factors for rectangular ferromagnetic prisms"<br/>
 J. Appl. Phys. 83 (1998) 3432 <a href="http://dx.doi.org/10.1063/1.367113" target="_top">[ J. Appl. Phys. 1 ]</a>, <a href="http://link.aip.org/link/?JAPIAU/83/3432/1" target="_top">[ J. Appl. Phys. 2 ]</a> </p>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

